Index: src/FLEXPART.f90
===================================================================
--- src/FLEXPART.f90	(revision db712a8ffdd9c478928d0173162055a7c109b178)
+++ src/FLEXPART.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -67,7 +67,8 @@
   call gasdev1(idummy,rannumb(maxrand),rannumb(maxrand-1))
 
+
   ! FLEXPART version string
   flexversion_major = '10' ! Major version number, also used for species file names
-  flexversion='Version '//trim(flexversion_major)//'.0beta (2015-05-01)'
+  flexversion='Version '//trim(flexversion_major)//'.1beta (2016-11-02)'
   verbosity=0
 
@@ -384,4 +385,15 @@
   end do
 
+  ! Inform whether output kernel is used or not
+  !*********************************************
+  if (lroot) then
+    if (lnokernel) then
+      write(*,*) "Concentrations are calculated without using kernel"
+    else
+      write(*,*) "Concentrations are calculated using kernel"
+    end if
+  end if
+
+
   ! Calculate particle trajectories
   !********************************
Index: src/FLEXPART_MPI.f90
===================================================================
--- src/FLEXPART_MPI.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
+++ src/FLEXPART_MPI.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -63,5 +63,7 @@
   ! Initialize arrays in com_mod 
   !*****************************
-  if (.not.lmpreader) call com_mod_allocate_part(maxpart_mpi)
+
+  if(.not.(lmpreader.and.lmp_use_reader)) call com_mod_allocate_part(maxpart_mpi)
+
 
   ! Generate a large number of random numbers
@@ -79,5 +81,5 @@
   flexversion_major = '10' ! Major version number, also used for species file names
 !  flexversion='Ver. 10 Beta MPI (2015-05-01)'
-  flexversion='Ver. '//trim(flexversion_major)//' Beta MPI (2015-05-01)'
+  flexversion='Ver. '//trim(flexversion_major)//'.1beta MPI (2016-11-02)'
   verbosity=0
 
@@ -306,5 +308,5 @@
   endif
 
-  if (.not.lmpreader) then
+  if (.not.(lmpreader.and.lmp_use_reader)) then
     do j=1, size(itra1) ! maxpart_mpi
       itra1(j)=-999999999
@@ -320,5 +322,5 @@
     endif
     ! readwind process skips this step
-    if (lmp_use_reader.and..not.lmpreader) call readpartpositions
+    if (.not.(lmpreader.and.lmp_use_reader)) call readpartpositions
   else
     if (verbosity.gt.0 .and. lroot) then
@@ -427,4 +429,14 @@
   end do
 
+  ! Inform whether output kernel is used or not
+  !*********************************************
+
+  if (lroot) then
+    if (lnokernel) then
+      write(*,*) "Concentrations are calculated without using kernel"
+    else
+      write(*,*) "Concentrations are calculated using kernel"
+    end if
+  end if
 
 ! Calculate particle trajectories
Index: src/com_mod.f90
===================================================================
--- src/com_mod.f90	(revision 62e65c73ae7e3d8c4b8b884065ede76e07211ec8)
+++ src/com_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -132,7 +132,7 @@
 
 !ZHG SEP 2015 wheather or not to read clouds from GRIB
-  logical :: readclouds
+  logical :: readclouds=.false.
 !ESO DEC 2015 whether or not both clwc and ciwc are present (if so they are summed)
-  logical :: sumclouds
+  logical :: sumclouds=.false.
 
   logical,dimension(maxnests) :: readclouds_nest, sumclouds_nest
@@ -743,5 +743,5 @@
 
   ! These variables are used to avoid having separate versions of
-  ! files in cases where differences with MPI version is minor (eso)
+  ! files in cases where differences with MPI version are minor (eso)
   !*****************************************************************
   integer :: mpi_mode=0 ! .gt. 0 if running MPI version
Index: src/conccalc.f90
===================================================================
--- src/conccalc.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
+++ src/conccalc.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -181,5 +181,5 @@
   !*****************************************************************************
 
-      if ((itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
+      if (lnokernel.or.(itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
            (xl.gt.real(numxgrid-1)-0.5).or. &
            (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell
Index: src/conccalc_mpi.f90
===================================================================
--- src/conccalc_mpi.f90	(revision 5f9d14aa526df192efa539f87fc409fdeeeee06c)
+++ src/conccalc_mpi.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -194,5 +194,5 @@
   !*****************************************************************************
 
-      if ((itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
+      if (lnokernel.or.(itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
            (xl.gt.real(numxgrid-1)-0.5).or. &
            (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell
Index: src/drydepokernel.f90
===================================================================
--- src/drydepokernel.f90	(revision e200b7adb07d4dfa7bf42f7cb43e0c85b4dbf894)
+++ src/drydepokernel.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -40,4 +40,9 @@
   !                                                                            *
   !*****************************************************************************
+  ! Changes:
+  ! eso 10/2016: Added option to disregard kernel 
+  ! 
+  !*****************************************************************************
+
 
   use unc_mod
@@ -47,5 +52,6 @@
   implicit none
 
-  real :: x,y,deposit(maxspec),ddx,ddy,xl,yl,wx,wy,w
+  real(dep_prec), dimension(maxspec) :: deposit
+  real :: x,y,ddx,ddy,xl,yl,wx,wy,w
   integer :: ix,jy,ixp,jyp,ks,nunc,nage,kp
 
@@ -74,18 +80,33 @@
   endif
 
+  ! If no kernel is used, direct attribution to grid cell
+  !******************************************************
+
+  if (lnokernel) then
+    do ks=1,nspec
+      if ((abs(deposit(ks)).gt.0).and.DRYDEPSPEC(ks)) then
+        if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
+             (jy.le.numygrid-1)) then
+          drygridunc(ix,jy,ks,kp,nunc,nage)= &
+               drygridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)
+        end if
+      end if
+    end do
+  else ! use kernel 
+
 
   ! Determine mass fractions for four grid points
   !**********************************************
-    do ks=1,nspec
+  do ks=1,nspec
 
-    if ((abs(deposit(ks)).gt.0).and.DRYDEPSPEC(ks)) then
+   if ((abs(deposit(ks)).gt.0).and.DRYDEPSPEC(ks)) then
 
    if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
         (jy.le.numygrid-1)) then
-    w=wx*wy
-      drygridunc(ix,jy,ks,kp,nunc,nage)= &
-           drygridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
-      continue
-  endif
+     w=wx*wy
+     drygridunc(ix,jy,ks,kp,nunc,nage)= &
+          drygridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
+     continue
+   endif
 
   if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgrid-1).and. &
@@ -112,5 +133,6 @@
   endif
 
-    end do
+  end do
+end if
 
 end subroutine drydepokernel
Index: src/drydepokernel_nest.f90
===================================================================
--- src/drydepokernel_nest.f90	(revision e200b7adb07d4dfa7bf42f7cb43e0c85b4dbf894)
+++ src/drydepokernel_nest.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -50,5 +50,6 @@
   implicit none
 
-  real :: x,y,deposit(maxspec),ddx,ddy,xl,yl,wx,wy,w
+  real(dep_prec), dimension(maxspec) :: deposit
+  real :: x,y,ddx,ddy,xl,yl,wx,wy,w
   integer :: ix,jy,ixp,jyp,ks,kp,nunc,nage
 
Index: src/gfs_mod.f90
===================================================================
--- src/gfs_mod.f90	(revision 62e65c73ae7e3d8c4b8b884065ede76e07211ec8)
+++ src/gfs_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -42,5 +42,6 @@
   !*********************************************
 
-  integer,parameter :: nxmax=721,nymax=361,nuvzmax=64,nwzmax=64,nzmax=64
+!  integer,parameter :: nxmax=721,nymax=361,nuvzmax=64,nwzmax=64,nzmax=64
+  integer,parameter :: nxmax=361,nymax=181,nuvzmax=64,nwzmax=64,nzmax=64
   integer,parameter :: nxshift=0     ! for GFS or FNL
 
Index: src/gridcheck_gfs.f90
===================================================================
--- src/gridcheck_gfs.f90	(revision 5f9d14aa526df192efa539f87fc409fdeeeee06c)
+++ src/gridcheck_gfs.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -421,16 +421,17 @@
   !********************
 
-  write(*,*)
-  write(*,*)
-  write(*,'(a,2i7)') 'Vertical levels in NCEP data: ', &
-       nuvz,nwz
-  write(*,*)
-  write(*,'(a)') 'Mother domain:'
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
-       xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range : ', &
-       ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
-  write(*,*)
-
+  if (lroot) then
+    write(*,*)
+    write(*,*)
+    write(*,'(a,2i7)') 'Vertical levels in NCEP data: ', &
+         nuvz,nwz
+    write(*,*)
+    write(*,'(a)') 'Mother domain:'
+    write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
+         xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
+    write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range : ', &
+         ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
+    write(*,*)
+  end if
 
   ! CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
Index: src/makefile
===================================================================
--- src/makefile	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ src/makefile	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -419,5 +419,5 @@
 	par_mod.o point_mod.o unc_mod.o xmass_mod.o
 timemanager_mpi.o: com_mod.o flux_mod.o mpi_mod.o oh_mod.o outg_mod.o \
-	par_mod.o point_mod.o unc_mod.o xmass_mod.o
+	par_mod.o point_mod.o unc_mod.o xmass_mod.o netcdf_output_mod.o	
 unc_mod.o: par_mod.o
 verttransform.o: cmapf_mod.o com_mod.o par_mod.o 
Index: src/mean_mod.f90
===================================================================
--- src/mean_mod.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
+++ src/mean_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -29,5 +29,7 @@
     module procedure mean_sp
     module procedure mean_dp
-    module procedure mean_mixed_prec
+    module procedure mean_mixed_dss
+    module procedure mean_mixed_dsd
+
   end interface mean
 
@@ -142,13 +144,13 @@
   end subroutine mean_dp
 
-  subroutine mean_mixed_prec(x_dp,xm,xs,number)
-
-!*****************************************************************************
-!                                                                            *
-!  This subroutine calculates mean and standard deviation of a given element.*
-!                                                                            *
-!      AUTHOR: Andreas Stohl, 25 January 1994                                *
-!                                                                            *
-!      Mixed precision version ESO 2016 (dp input, sp output)                *
+  subroutine mean_mixed_dss(x_dp,xm,xs,number)
+
+!*****************************************************************************
+!                                                                            *
+!  This subroutine calculates mean and standard deviation of a given element.*
+!                                                                            *
+!      AUTHOR: Andreas Stohl, 25 January 1994                                *
+!                                                                            *
+!      Mixed precision version ESO 2016 (dp in, sp out, sp out)              *
 !*****************************************************************************
 !                                                                            *
@@ -192,4 +194,58 @@
     endif
 
-  end subroutine mean_mixed_prec
+  end subroutine mean_mixed_dss
+
+  subroutine mean_mixed_dsd(x_dp,xm,xs_dp,number)
+
+!*****************************************************************************
+!                                                                            *
+!  This subroutine calculates mean and standard deviation of a given element.*
+!                                                                            *
+!      AUTHOR: Andreas Stohl, 25 January 1994                                *
+!                                                                            *
+!      Mixed precision version ESO 2016 (dp in, sp out, dp out)              *
+!*****************************************************************************
+!                                                                            *
+! Variables:                                                                 *
+! x_dp(number)        field of input data                                    *
+! xm                  mean                                                   *
+! xs_dp               standard deviation                                     *
+! number              number of elements of field x_dp                       *
+!                                                                            *
+! Constants:                                                                 *
+! eps                 tiny number                                            *
+!                                                                            *
+!*****************************************************************************
+
+    use par_mod, only: sp,dp
+
+    implicit none
+
+    integer,intent(in) :: number
+    real(dp), intent(in) :: x_dp(number)
+    real(sp), intent(out) ::xm
+    real(dp), intent(out) ::xs_dp
+    real(dp) :: xl,xq,xaux
+    real(dp),parameter :: eps=1.0e-30_dp
+    integer :: i
+
+    xl=0._dp
+    xq=0._dp
+    do i=1,number
+      xl=xl+x_dp(i)
+      xq=xq+x_dp(i)*x_dp(i)
+    end do
+
+    xm=xl/real(number,kind=sp)
+
+    xaux=xq-xl*xl/real(number,kind=dp)
+
+    if (xaux.lt.eps) then
+      xs_dp=0._dp
+    else
+      xs_dp=sqrt(xaux/real(number-1,kind=dp))
+    endif
+
+  end subroutine mean_mixed_dsd
+
 end module mean_mod
Index: src/mpi_mod.f90
===================================================================
--- src/mpi_mod.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
+++ src/mpi_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -331,5 +331,5 @@
 ! Set maxpart per process
 ! eso 08/2016: Increase maxpart per process, in case of unbalanced distribution
-    maxpart_mpi=int(mp_maxpart_factor*maxpart/mp_partgroup_np)
+    maxpart_mpi=int(mp_maxpart_factor*real(maxpart)/real(mp_partgroup_np))
 
 ! Do not allocate particle data arrays for readwind process
@@ -832,6 +832,6 @@
       numpart=max(numpart,ipart)
 
-      deallocate(itra1_tmp,npoint_tmp,nclass_tmp,idt_tmp,itramem_tmp,itrasplit_tmp,&
-           & xtra1_tmp,ytra1_tmp,ztra1_tmp,xmass1_tmp)
+      deallocate(itra1_tmp,npoint_tmp,nclass_tmp,idt_tmp,itramem_tmp,&
+           &itrasplit_tmp,xtra1_tmp,ytra1_tmp,ztra1_tmp,xmass1_tmp)
 
       if (mp_dev_mode) then
@@ -2340,5 +2340,7 @@
 !
 ! TODO
-!   take into account nested wind fields
+!   NB: take into account nested wind fields by using a separate 
+!   subroutine mpif_gf_request_nest (and separate request arrays for the
+!   nested variables)
 !
 !*******************************************************************************
Index: src/netcdf_output_mod.f90
===================================================================
--- src/netcdf_output_mod.f90	(revision f28aa0a11ef276a96d9591cea9bca7371c98ad03)
+++ src/netcdf_output_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -19,4 +19,5 @@
 !**********************************************************************
 
+
   !*****************************************************************************
   !                                                                            *
@@ -24,7 +25,7 @@
   !  residence time and wet and dry deposition output.                         *
   !                                                                            *
-  !  - writeheader_netcdf generates file including all information previously    *
+  !  - writeheader_netcdf generates file including all information previously  *
   !    stored in separate header files                                         *
-  !  - concoutput_netcdf write concentration output and wet and dry deposition   *
+  !  - concoutput_netcdf write concentration output and wet and dry deposition *
   !                                                                            *
   !     Author: D. Brunner                                                     *
@@ -893,10 +894,10 @@
   gridsigmatotal=0.
   gridtotalunc=0.
-  wetgridtotal=0.
-  wetgridsigmatotal=0.
-  wetgridtotalunc=0.
-  drygridtotal=0.
-  drygridsigmatotal=0.
-  drygridtotalunc=0.
+  wetgridtotal=0._dep_prec
+  wetgridsigmatotal=0._dep_prec
+  wetgridtotalunc=0._dep_prec
+  drygridtotal=0._dep_prec
+  drygridsigmatotal=0._dep_prec
+  drygridtotalunc=0._dep_prec
 
   do ks=1,nspec
@@ -922,5 +923,5 @@
                    wetgridsigma(ix,jy),nclassunc)
               ! Multiply by number of classes to get total concentration
-              wetgrid(ix,jy)=wetgrid(ix,jy)*real(nclassunc,kind=dep_prec)
+              wetgrid(ix,jy)=wetgrid(ix,jy)*real(nclassunc,kind=sp)
               wetgridtotal=wetgridtotal+wetgrid(ix,jy)
               ! Calculate standard deviation of the mean
@@ -946,10 +947,10 @@
                    drygridsigma(ix,jy),nclassunc)
               ! Multiply by number of classes to get total concentration
-              drygrid(ix,jy)=drygrid(ix,jy)*real(nclassunc)
+              drygrid(ix,jy)=drygrid(ix,jy)*real(nclassunc,kind=sp)
               drygridtotal=drygridtotal+drygrid(ix,jy)
               ! Calculate standard deviation of the mean
               drygridsigma(ix,jy)= &
                    drygridsigma(ix,jy)* &
-                   sqrt(real(nclassunc))
+                   sqrt(real(nclassunc, kind=dep_prec))
               drygridsigmatotal=drygridsigmatotal+ &
                    drygridsigma(ix,jy)
@@ -1054,6 +1055,6 @@
   if (wetgridtotal.gt.0.) wetgridtotalunc=wetgridsigmatotal/ &
        wetgridtotal
-  if (drygridtotal.gt.0.) drygridtotalunc=drygridsigmatotal/ &
-       drygridtotal
+  if (drygridtotal.gt.0.) drygridtotalunc=real(drygridsigmatotal/ &
+       drygridtotal, kind=dep_prec)
 
   ! Dump of receptor concentrations
@@ -1298,5 +1299,5 @@
               wetgridsigma(ix,jy)= &
                    wetgridsigma(ix,jy)* &
-                   sqrt(real(nclassunc))
+                   sqrt(real(nclassunc,kind=dep_prec))
             endif
 
@@ -1319,5 +1320,5 @@
               drygridsigma(ix,jy)= &
                    drygridsigma(ix,jy)* &
-                   sqrt(real(nclassunc))
+                   sqrt(real(nclassunc,kind=dep_prec))
             endif
 
Index: src/outg_mod.f90
===================================================================
--- src/outg_mod.f90	(revision 6a678e3fe206788e9704a724ec54e6d3dcc908e7)
+++ src/outg_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -22,5 +22,5 @@
 module outg_mod
 
-  use par_mod, only: dep_prec
+  use par_mod, only: dep_prec, sp
 
   implicit none
@@ -39,6 +39,6 @@
   real,allocatable, dimension (:,:,:) :: factor3d
   real,allocatable, dimension (:,:,:) :: grid
-  real(dep_prec),allocatable, dimension (:,:) :: wetgrid
-  real(dep_prec),allocatable, dimension (:,:) :: drygrid
+  real(sp),allocatable, dimension (:,:) :: wetgrid
+  real(sp),allocatable, dimension (:,:) :: drygrid
   real,allocatable, dimension (:,:,:) :: gridsigma
   real(dep_prec),allocatable, dimension (:,:) :: drygridsigma
Index: src/par_mod.f90
===================================================================
--- src/par_mod.f90	(revision 3b80e9858bae10a9d9465d523f0b2997940c2a0f)
+++ src/par_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -58,4 +58,10 @@
 
   integer,parameter :: dep_prec=sp
+
+  !****************************************************************
+  ! Set to T to disable use of kernel for concentrations/deposition
+  !****************************************************************
+
+  logical, parameter :: lnokernel=.false.
 
   !***********************************************************
Index: src/readavailable.f90
===================================================================
--- src/readavailable.f90	(revision db712a8ffdd9c478928d0173162055a7c109b178)
+++ src/readavailable.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -236,10 +236,10 @@
   do i=2,numbwf
     idiff=abs(wftime(i)-wftime(i-1))
-    if (idiff.gt.idiffmax) then
+    if (idiff.gt.idiffmax.and.lroot) then
       write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
       write(*,*) 'WIND FIELDS IS TOO BIG FOR TRANSPORT CALCULATION.&
            &'
       write(*,*) 'THEREFORE, TRAJECTORIES HAVE TO BE SKIPPED.'
-    else if (idiff.gt.idiffnorm) then
+    else if (idiff.gt.idiffnorm.and.lroot) then
       write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
       write(*,*) 'WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION'
Index: src/readcommand.f90
===================================================================
--- src/readcommand.f90	(revision c04b739b567dd89ec6a4491a728fbe13d3bd0b68)
+++ src/readcommand.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -170,8 +170,10 @@
     if (index(line,'LDIRECT') .eq. 0) then
       old = .false.
-      write(*,*) 'COMMAND in old short format, please update to namelist format'
+      if (lroot) write(*,*) 'COMMAND in old short format, &
+           &please update to namelist format'
     else
       old = .true.
-      write(*,*) 'COMMAND in old long format, please update to namelist format'
+      if (lroot) write(*,*) 'COMMAND in old long format, &
+           &please update to namelist format'
     endif
     rewind(unitcommand)
Index: src/readreleases.f90
===================================================================
--- src/readreleases.f90	(revision 05cf28de9ff073ff7e3cdc064f0ed59c61a6dd09)
+++ src/readreleases.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -218,4 +218,6 @@
   rewind(unitreleases)
 
+  if (nspec.gt.maxspec) goto 994
+
   ! allocate arrays of matching size for number of species (namelist output)
   deallocate(mass)
@@ -574,4 +576,5 @@
   endif
 
+
   ! Determine the release rate (particles per second) and total number
   ! of particles released during the simulation
@@ -633,4 +636,8 @@
   endif
 
+  if (lroot) then
+    write(*,FMT='(A,ES14.7)') ' Total mass released:', sum(xmass(1:numpoint,1:nspec))
+  end if
+
   return
 
Index: src/unc_mod.f90
===================================================================
--- src/unc_mod.f90	(revision 6a678e3fe206788e9704a724ec54e6d3dcc908e7)
+++ src/unc_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -26,5 +26,5 @@
   implicit none
 
-  real,allocatable ,dimension (:,:,:,:,:,:,:) :: gridunc
+  real,allocatable, dimension (:,:,:,:,:,:,:) :: gridunc
   real,allocatable, dimension (:,:,:,:,:,:,:) :: griduncn
   real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: drygridunc
Index: src/wetdepokernel.f90
===================================================================
--- src/wetdepokernel.f90	(revision e200b7adb07d4dfa7bf42f7cb43e0c85b4dbf894)
+++ src/wetdepokernel.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -40,4 +40,8 @@
   !                                                                            *
   !*****************************************************************************
+  ! Changes:
+  ! eso 10/2016: Added option to disregard kernel 
+  ! 
+  !*****************************************************************************
 
   use unc_mod
@@ -73,5 +77,17 @@
   endif
 
+  ! If no kernel is used, direct attribution to grid cell
+  !******************************************************
 
+  if (lnokernel) then
+    do ks=1,nspec
+      if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
+           (jy.le.numygrid-1)) then
+        wetgridunc(ix,jy,ks,kp,nunc,nage)= &
+             wetgridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)
+      end if
+    end do
+  else ! use kernel 
+    
   ! Determine mass fractions for four grid points
   !**********************************************
@@ -107,4 +123,5 @@
   endif
   end do
+  end if
 
 end subroutine wetdepokernel